Save invoices
curl --request POST \
--url https://sandbox.tight.com/v6/invoicing/invoices \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"data": [
{
"customerId": "cus_28868401",
"id": "inv_158998869",
"invoiceNumber": "HAR-1",
"invoiceStatus": "OPEN",
"date": "2025-06-26",
"dimensionValueIds": [
"<string>"
],
"notes": "Thank you for your business!",
"lineItems": [
{
"description": "Consulting services",
"quantity": 2,
"rate": 5000,
"id": "ili_28868401",
"apiItemId": "ext_item_123",
"glAccountId": "gla_38560327",
"timeId": "tme_28868401",
"expenseId": "btxn_28868401",
"invoiceItemTemplateId": "tili_28868401"
}
],
"collectionInfo": {
"paymentMethods": [],
"term": {
"type": "NET_30",
"dueDate": "2025-07-26"
},
"sendEmail": true,
"email": "customer@example.com",
"sendSMS": true,
"phone": "+14155551234",
"ccEmails": [
"<string>"
],
"bccEmails": [
"<string>"
],
"reminderSchedule": []
},
"recurrence": {
"updateType": "FUTURE_ONLY",
"frequency": "MONTHLY",
"interval": 1,
"occurrences": 12
},
"installments": [
{
"id": "istl_123",
"name": "First installment"
}
],
"apiName": "QBO",
"apiSourceId": "ext_123",
"customData": {
"internal_key": "some_internal_key",
"some_other_field": 23434
}
}
]
}
'import requests
url = "https://sandbox.tight.com/v6/invoicing/invoices"
payload = { "data": [
{
"customerId": "cus_28868401",
"id": "inv_158998869",
"invoiceNumber": "HAR-1",
"invoiceStatus": "OPEN",
"date": "2025-06-26",
"dimensionValueIds": ["<string>"],
"notes": "Thank you for your business!",
"lineItems": [
{
"description": "Consulting services",
"quantity": 2,
"rate": 5000,
"id": "ili_28868401",
"apiItemId": "ext_item_123",
"glAccountId": "gla_38560327",
"timeId": "tme_28868401",
"expenseId": "btxn_28868401",
"invoiceItemTemplateId": "tili_28868401"
}
],
"collectionInfo": {
"paymentMethods": [],
"term": {
"type": "NET_30",
"dueDate": "2025-07-26"
},
"sendEmail": True,
"email": "customer@example.com",
"sendSMS": True,
"phone": "+14155551234",
"ccEmails": ["<string>"],
"bccEmails": ["<string>"],
"reminderSchedule": []
},
"recurrence": {
"updateType": "FUTURE_ONLY",
"frequency": "MONTHLY",
"interval": 1,
"occurrences": 12
},
"installments": [
{
"id": "istl_123",
"name": "First installment"
}
],
"apiName": "QBO",
"apiSourceId": "ext_123",
"customData": {
"internal_key": "some_internal_key",
"some_other_field": 23434
}
}
] }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
data: [
{
customerId: 'cus_28868401',
id: 'inv_158998869',
invoiceNumber: 'HAR-1',
invoiceStatus: 'OPEN',
date: '2025-06-26',
dimensionValueIds: ['<string>'],
notes: 'Thank you for your business!',
lineItems: [
{
description: 'Consulting services',
quantity: 2,
rate: 5000,
id: 'ili_28868401',
apiItemId: 'ext_item_123',
glAccountId: 'gla_38560327',
timeId: 'tme_28868401',
expenseId: 'btxn_28868401',
invoiceItemTemplateId: 'tili_28868401'
}
],
collectionInfo: {
paymentMethods: [],
term: {type: 'NET_30', dueDate: '2025-07-26'},
sendEmail: true,
email: 'customer@example.com',
sendSMS: true,
phone: '+14155551234',
ccEmails: ['<string>'],
bccEmails: ['<string>'],
reminderSchedule: []
},
recurrence: {updateType: 'FUTURE_ONLY', frequency: 'MONTHLY', interval: 1, occurrences: 12},
installments: [{id: 'istl_123', name: 'First installment'}],
apiName: 'QBO',
apiSourceId: 'ext_123',
customData: {internal_key: 'some_internal_key', some_other_field: 23434}
}
]
})
};
fetch('https://sandbox.tight.com/v6/invoicing/invoices', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"result": "SUCCESS",
"data": [
{
"result": "SUCCESS",
"statusCode": 200,
"data": {
"id": "inv_158998869",
"invoiceNumber": "HAR-1",
"status": "ACTIVE",
"invoiceStatus": "OPEN",
"detailedInvoiceDisplayStatus": "Overdue",
"date": "2025-06-26",
"customerInvoiceUrl": "https://invoices.tight.com/inv_158998869",
"customer": {
"id": "cus_4852707",
"name": "Abigail Adams",
"email": "abigail@tight.com"
},
"dimensionValues": [
{
"id": "dv_593051",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Mid-Atlantic",
"child": {
"id": "dv_593052",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Washington DC",
"child": "<unknown>"
}
}
],
"notes": "Thank you for your business!",
"discount": {
"value": "5",
"type": "PERCENT",
"calculateBeforeSalesTax": true
},
"deposit": {
"value": "5000",
"type": "PERCENT"
},
"totals": {
"subtotal": 10000,
"discountedTotal": 9500,
"salesTax": 843,
"total": 10343,
"paidAmount": 5000,
"balance": 5343
},
"collectionInfo": {
"term": {
"type": "NET_30",
"dueDate": "2025-07-26"
},
"sendEmail": true,
"sendSms": true,
"email": "customer@example.com",
"reminderSchedule": [
"THREE_DAYS_BEFORE_DUE_DATE"
],
"paymentMethods": [
"CREDIT_CARD"
],
"ccEmails": [
"cc@example.com"
],
"bccEmails": [
"bcc@example.com"
]
},
"recurrence": {
"frequency": "MONTHLY",
"interval": 1,
"occurrences": 12,
"endDate": "2025-12-31"
},
"apiName": "QBO",
"apiSourceId": "ext_123",
"lineItems": [
{
"id": "ili_28868401",
"description": "Consulting services",
"quantity": 2,
"rate": 5000,
"salesTax": {
"value": "8.875",
"type": "PERCENT"
},
"apiItemId": "ext_item_123",
"glAccount": {
"id": "gla_38560327",
"name": "Officer(s) Salaries and Wages",
"accountNo": "60210",
"type": "EXPENSE",
"iconUrl": "https://cdn.sandbox.tight.com/icons/glAccountTypes/expense.png",
"displayName": "#60210 Officer(s) Salaries and Wages"
},
"timeId": "tme_28868401",
"expenseId": "btxn_28868401"
}
],
"installments": [
{
"id": "istl_123",
"name": "First installment",
"dueDate": "2025-07-15",
"balance": 10000,
"amountDue": {
"value": "5000",
"type": "AMOUNT"
}
}
],
"payments": [
{
"id": "ptxn_158998869",
"date": "2025-07-01",
"amount": 12000,
"allocatedAmount": 5000
}
],
"activity": [
{
"type": "INITIAL_EMAIL_SENT",
"datetime": "2023-11-07T05:31:56Z",
"status": "SUCCESS",
"error": "The recipient's mail server rejected the message."
}
],
"customData": {
"internal_key": "some_internal_key",
"some_other_field": 23434
}
},
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}
],
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}{
"result": "SUCCESS",
"data": [
{
"result": "SUCCESS",
"statusCode": 200,
"data": {
"id": "inv_158998869",
"invoiceNumber": "HAR-1",
"status": "ACTIVE",
"invoiceStatus": "OPEN",
"detailedInvoiceDisplayStatus": "Overdue",
"date": "2025-06-26",
"customerInvoiceUrl": "https://invoices.tight.com/inv_158998869",
"customer": {
"id": "cus_4852707",
"name": "Abigail Adams",
"email": "abigail@tight.com"
},
"dimensionValues": [
{
"id": "dv_593051",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Mid-Atlantic",
"child": {
"id": "dv_593052",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Washington DC",
"child": "<unknown>"
}
}
],
"notes": "Thank you for your business!",
"discount": {
"value": "5",
"type": "PERCENT",
"calculateBeforeSalesTax": true
},
"deposit": {
"value": "5000",
"type": "PERCENT"
},
"totals": {
"subtotal": 10000,
"discountedTotal": 9500,
"salesTax": 843,
"total": 10343,
"paidAmount": 5000,
"balance": 5343
},
"collectionInfo": {
"term": {
"type": "NET_30",
"dueDate": "2025-07-26"
},
"sendEmail": true,
"sendSms": true,
"email": "customer@example.com",
"reminderSchedule": [
"THREE_DAYS_BEFORE_DUE_DATE"
],
"paymentMethods": [
"CREDIT_CARD"
],
"ccEmails": [
"cc@example.com"
],
"bccEmails": [
"bcc@example.com"
]
},
"recurrence": {
"frequency": "MONTHLY",
"interval": 1,
"occurrences": 12,
"endDate": "2025-12-31"
},
"apiName": "QBO",
"apiSourceId": "ext_123",
"lineItems": [
{
"id": "ili_28868401",
"description": "Consulting services",
"quantity": 2,
"rate": 5000,
"salesTax": {
"value": "8.875",
"type": "PERCENT"
},
"apiItemId": "ext_item_123",
"glAccount": {
"id": "gla_38560327",
"name": "Officer(s) Salaries and Wages",
"accountNo": "60210",
"type": "EXPENSE",
"iconUrl": "https://cdn.sandbox.tight.com/icons/glAccountTypes/expense.png",
"displayName": "#60210 Officer(s) Salaries and Wages"
},
"timeId": "tme_28868401",
"expenseId": "btxn_28868401"
}
],
"installments": [
{
"id": "istl_123",
"name": "First installment",
"dueDate": "2025-07-15",
"balance": 10000,
"amountDue": {
"value": "5000",
"type": "AMOUNT"
}
}
],
"payments": [
{
"id": "ptxn_158998869",
"date": "2025-07-01",
"amount": 12000,
"allocatedAmount": 5000
}
],
"activity": [
{
"type": "INITIAL_EMAIL_SENT",
"datetime": "2023-11-07T05:31:56Z",
"status": "SUCCESS",
"error": "The recipient's mail server rejected the message."
}
],
"customData": {
"internal_key": "some_internal_key",
"some_other_field": 23434
}
},
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}
],
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}{
"result": "SUCCESS",
"data": [
{
"result": "SUCCESS",
"statusCode": 200,
"data": {
"id": "inv_158998869",
"invoiceNumber": "HAR-1",
"status": "ACTIVE",
"invoiceStatus": "OPEN",
"detailedInvoiceDisplayStatus": "Overdue",
"date": "2025-06-26",
"customerInvoiceUrl": "https://invoices.tight.com/inv_158998869",
"customer": {
"id": "cus_4852707",
"name": "Abigail Adams",
"email": "abigail@tight.com"
},
"dimensionValues": [
{
"id": "dv_593051",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Mid-Atlantic",
"child": {
"id": "dv_593052",
"dimension": {
"id": "dim_4521",
"name": "Region",
"requiredness": "NOT_REQUIRED"
},
"name": "Washington DC",
"child": "<unknown>"
}
}
],
"notes": "Thank you for your business!",
"discount": {
"value": "5",
"type": "PERCENT",
"calculateBeforeSalesTax": true
},
"deposit": {
"value": "5000",
"type": "PERCENT"
},
"totals": {
"subtotal": 10000,
"discountedTotal": 9500,
"salesTax": 843,
"total": 10343,
"paidAmount": 5000,
"balance": 5343
},
"collectionInfo": {
"term": {
"type": "NET_30",
"dueDate": "2025-07-26"
},
"sendEmail": true,
"sendSms": true,
"email": "customer@example.com",
"reminderSchedule": [
"THREE_DAYS_BEFORE_DUE_DATE"
],
"paymentMethods": [
"CREDIT_CARD"
],
"ccEmails": [
"cc@example.com"
],
"bccEmails": [
"bcc@example.com"
]
},
"recurrence": {
"frequency": "MONTHLY",
"interval": 1,
"occurrences": 12,
"endDate": "2025-12-31"
},
"apiName": "QBO",
"apiSourceId": "ext_123",
"lineItems": [
{
"id": "ili_28868401",
"description": "Consulting services",
"quantity": 2,
"rate": 5000,
"salesTax": {
"value": "8.875",
"type": "PERCENT"
},
"apiItemId": "ext_item_123",
"glAccount": {
"id": "gla_38560327",
"name": "Officer(s) Salaries and Wages",
"accountNo": "60210",
"type": "EXPENSE",
"iconUrl": "https://cdn.sandbox.tight.com/icons/glAccountTypes/expense.png",
"displayName": "#60210 Officer(s) Salaries and Wages"
},
"timeId": "tme_28868401",
"expenseId": "btxn_28868401"
}
],
"installments": [
{
"id": "istl_123",
"name": "First installment",
"dueDate": "2025-07-15",
"balance": 10000,
"amountDue": {
"value": "5000",
"type": "AMOUNT"
}
}
],
"payments": [
{
"id": "ptxn_158998869",
"date": "2025-07-01",
"amount": 12000,
"allocatedAmount": 5000
}
],
"activity": [
{
"type": "INITIAL_EMAIL_SENT",
"datetime": "2023-11-07T05:31:56Z",
"status": "SUCCESS",
"error": "The recipient's mail server rejected the message."
}
],
"customData": {
"internal_key": "some_internal_key",
"some_other_field": 23434
}
},
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}
],
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "<string>",
"param": "<string>"
}
]
}{
"result": "FAILURE",
"error": [
{
"type": "INVALID_TOKEN",
"message": "Invalid access token"
}
]
}{
"result": "FAILURE",
"error": [
{
"type": "FORBIDDEN",
"message": "Expired access token"
}
]
}{
"result": "FAILURE",
"error": [
{
"type": "BAD_REQUEST",
"message": "Resource not found"
}
]
}{
"result": "FAILURE",
"error": [
{
"type": "UNKNOWN_ERROR",
"message": "Something went wrong. Please try again later."
}
]
}Invoicing (A/R)
Save invoices
Save new (or update existing) invoices
POST
/
v6
/
invoicing
/
invoices
Save invoices
Authorizations
Bearer authentication header of the form Bearer <token>, see Authentication for more detail.
Body
application/json
Show child attributes
Show child attributes